;Colour bars program
;-------------------
;Binary created using DAsm 2.12 running on an Amiga.

   PROCESSOR   6502

   ORG   $C000    ;16Kb PRG-ROM, 16Kb CHR-ROM

Reset_Routine  SUBROUTINE
   cld         ;Clear decimal flag
   sei         ;Disable interrupts
.WaitV   lda $2002
   bpl .WaitV     ;Wait for vertical blanking interval
   ldx #$00
   stx $2000
   stx $2001      ;Screen display off, amongst other things
   dex
   txs         ;Top of stack at $1FF

;Clear (most of) the NES' WRAM. This routine is ripped from "Duck Hunt" - I should probably clear all
;$800 bytes.
   ldy #$06    ;To clear 7 x $100 bytes, from $000 to $6FF?
   sty $01        ;Store count value in $01
   ldy #$00
   sty $00
   lda #$00

.Clear   sta ($00),y    ;Clear $100 bytes
   dey
   bne .Clear

   dec $01        ;Decrement "banks" left counter
   bpl .Clear     ;Do next if >= 0


;********* Initialize Palette to specified colour ********

   ldx   #$3F
   stx   $2006
   ldx   #$00
   stx   $2006

   ldx   #$0D     ;Colour Value (Black)
   ldy   #$20     ;Clear BG & Sprite palettes.
.InitPal stx $2007
   dey
   bne   .InitPal
;*********************************************************

   lda   #$20
   sta   $2006
   lda   #$00
   sta   $2006       ;Point 0 rows down in Name Table.

   ldx   #$10          ;-
   txa                 ; \
.DefMap0 ldy   #$10
   tax
.DefMap1 stx $2007
   inx                     ;This part sets up two identical columns
   dey                     ;Of Pattern Tables $10-$FF
   bne   .DefMap1
   ldy   #$10
   tax
.DefMap2 stx $2007
   inx
   dey
   bne   .DefMap2
   txa
   cpx   #$00          ; /
   bne   .DefMap0      ;-

   ldx   #$10          ;-
   txa                 ; \
.DefMap3 ldy   #$10
   tax
.DefMap4 stx $2007
   inx                     ;This part sets up two identical columns
   dey                     ;Of Pattern Tables $10-$FF
   bne   .DefMap4
   ldy   #$10
   tax
.DefMap5 stx $2007
   inx
   dey
   bne   .DefMap5
   txa
   cpx   #$00          ; /
   bne   .DefMap3      ;-

;------------------------------
;Set up Attribute Table
   lda   #$23
   sta   $2006
   lda   #$C0
   sta   $2006       ;Point to right spot in Attr. Map

   ldy   #$08
.DrawAtt lda   #$00
   sta   $2007
   sta   $2007
   sta   $2007
   sta   $2007
   lda   #$55        ;Palette #1
   sta   $2007
   sta   $2007
   sta   $2007
   sta   $2007
   dey
   bne   .DrawAtt
;------------------------------
;Set up Sprite
   lda   #$00
   sta   $2003    ;Point to Sprite 0
   lda   #$76
   sta   $2004
   lda   #$01
   sta   $2004
   lda   #%00000000
   sta   $2004
   lda   #$80
   sta   $2004

;-------------------------------
;Set up Palette

   lda   #$3F
   sta   $2006
   lda   #$01
   sta   $2006

   lda   #$30
   sta   $2007
   sta   $2007
   lda   #$0D
   sta   $2007
   sta   $2007
   sta   $2007
   lda   #$30
   sta   $2007
   sta   $2007

   lda   #$3F
   sta   $2006
   lda   #$11
   sta   $2006
   lda   #$30
   sta   $2007       ;Set up Sprite Palette

   lda   #$00
   sta   $2006
   sta   $2006       ;Reset PPU
   sta   $2005
   sta   $2005       ;Reset Scroll

   lda   #$00
   sta   $50
   sta   $C000       ;Set up Mapper???

;Enable vblank interrupts, etc.
   lda   #%10001000
   sta   $2000
   lda   #%00011110   ;Screen on, sprites on, show leftmost 8 pixels, colour
   sta   $2001
;  cli            ;Enable interrupts(?)

   lda   #$01
   sta   $40      ;Store no VB flag

;Now just loop forever?
.Loop

;   lda   $40
;   bne   .NoCheck
.CheckSpr lda   #%01000000
   and   $2002          ;Check for Sprite Hit
   beq   .CheckSpr
   lda   #%10011000
   sta   $2000
   lda   #$00
   sta   $40


.NoCheck
   jmp   .Loop


NMI_Routine SUBROUTINE
   pha
   txa
   pha
   tya
   pha

   lda   $50
   eor   #$01
   sta   $50
   sta   $C000

   lda   #%10001000
   sta   $2000
   lda   #$01
   sta   $40         ;Stores VBlank flag (for me)

   lda   #$00
   sta   $2006
   sta   $2006
   sta   $2005
   sta   $2005

   pla
   tay
   pla
   tax
   pla
   rti

IRQ_Routine       ;Dummy label
   rti

;That's all the code. Now we just need to set the vector table approriately.

   ORG   $FFFA,0
   dc.w  NMI_Routine
   dc.w  Reset_Routine
   dc.w  IRQ_Routine    ;Not used, just points to RTI


;The end.
